Index: /branches/proxy/src/lib/util/sigslot/signal.h
===================================================================
--- /branches/proxy/src/lib/util/sigslot/signal.h	(revision 9367)
+++ /branches/proxy/src/lib/util/sigslot/signal.h	(revision 9368)
@@ -1218,40 +1218,40 @@
   class _connection0 : public _connection_base0<mt_policy>
   {
-    public:
-      _connection0()
-      {
-        pobject = NULL;
-        pmemfun = NULL;
-      }
-
-      _connection0(dest_type* pobject, void (dest_type::*pmemfun)())
-      {
-        m_pobject = pobject;
-        m_pmemfun = pmemfun;
-      }
-
-      virtual _connection_base0<mt_policy>* clone()
-      {
-        return new _connection0<dest_type, mt_policy>(*this);
-      }
-
-      virtual _connection_base0<mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
-      {
-        return new _connection0<dest_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
-      }
-
-      virtual void emit()
-      {
-        (m_pobject->*m_pmemfun)();
-      }
-
-      virtual has_slots<mt_policy>* getdest() const
-      {
-        return m_pobject;
-      }
-
-    private:
-      dest_type* m_pobject;
-      void (dest_type::* m_pmemfun)();
+  public:
+    _connection0()
+    {
+      m_pobject = NULL;
+      m_pmemfun = NULL;
+    }
+
+    _connection0(dest_type* pobject, void (dest_type::*pmemfun)())
+    {
+      m_pobject = pobject;
+      m_pmemfun = pmemfun;
+    }
+
+    virtual _connection_base0<mt_policy>* clone()
+    {
+      return new _connection0<dest_type, mt_policy>(*this);
+    }
+
+    virtual _connection_base0<mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
+    {
+      return new _connection0<dest_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
+    }
+
+    virtual void emit()
+    {
+      (m_pobject->*m_pmemfun)();
+    }
+
+    virtual has_slots<mt_policy>* getdest() const
+    {
+      return m_pobject;
+    }
+
+  private:
+    dest_type* m_pobject;
+    void (dest_type::* m_pmemfun)();
   };
 
@@ -1259,40 +1259,40 @@
   class _connection1 : public _connection_base1<arg1_type, mt_policy>
   {
-    public:
-      _connection1()
-      {
-        pobject = NULL;
-        pmemfun = NULL;
-      }
-
-      _connection1(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type))
-      {
-        m_pobject = pobject;
-        m_pmemfun = pmemfun;
-      }
-
-      virtual _connection_base1<arg1_type, mt_policy>* clone()
-      {
-        return new _connection1<dest_type, arg1_type, mt_policy>(*this);
-      }
-
-      virtual _connection_base1<arg1_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
-      {
-        return new _connection1<dest_type, arg1_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
-      }
-
-      virtual void emit(arg1_type a1)
-      {
-        (m_pobject->*m_pmemfun)(a1);
-      }
-
-      virtual has_slots<mt_policy>* getdest() const
-      {
-        return m_pobject;
-      }
-
-    private:
-      dest_type* m_pobject;
-      void (dest_type::* m_pmemfun)(arg1_type);
+  public:
+    _connection1()
+    {
+      m_pobject = NULL;
+      m_pmemfun = NULL;
+    }
+
+    _connection1(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type))
+    {
+      m_pobject = pobject;
+      m_pmemfun = pmemfun;
+    }
+
+    virtual _connection_base1<arg1_type, mt_policy>* clone()
+    {
+      return new _connection1<dest_type, arg1_type, mt_policy>(*this);
+    }
+
+    virtual _connection_base1<arg1_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
+    {
+      return new _connection1<dest_type, arg1_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
+    }
+
+    virtual void emit(arg1_type a1)
+    {
+      (m_pobject->*m_pmemfun)(a1);
+    }
+
+    virtual has_slots<mt_policy>* getdest() const
+    {
+      return m_pobject;
+    }
+
+  private:
+    dest_type* m_pobject;
+    void (dest_type::* m_pmemfun)(arg1_type);
   };
 
@@ -1300,41 +1300,41 @@
   class _connection2 : public _connection_base2<arg1_type, arg2_type, mt_policy>
   {
-    public:
-      _connection2()
-      {
-        pobject = NULL;
-        pmemfun = NULL;
-      }
-
-      _connection2(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
-                   arg2_type))
-      {
-        m_pobject = pobject;
-        m_pmemfun = pmemfun;
-      }
-
-      virtual _connection_base2<arg1_type, arg2_type, mt_policy>* clone()
-      {
-        return new _connection2<dest_type, arg1_type, arg2_type, mt_policy>(*this);
-      }
-
-      virtual _connection_base2<arg1_type, arg2_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
-      {
-        return new _connection2<dest_type, arg1_type, arg2_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
-      }
-
-      virtual void emit(arg1_type a1, arg2_type a2)
-      {
-        (m_pobject->*m_pmemfun)(a1, a2);
-      }
-
-      virtual has_slots<mt_policy>* getdest() const
-      {
-        return m_pobject;
-      }
-
-    private:
-      dest_type* m_pobject;
-      void (dest_type::* m_pmemfun)(arg1_type, arg2_type);
+  public:
+    _connection2()
+    {
+      m_pobject = NULL;
+      m_pmemfun = NULL;
+    }
+
+    _connection2(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
+                 arg2_type))
+    {
+      m_pobject = pobject;
+      m_pmemfun = pmemfun;
+    }
+
+    virtual _connection_base2<arg1_type, arg2_type, mt_policy>* clone()
+    {
+      return new _connection2<dest_type, arg1_type, arg2_type, mt_policy>(*this);
+    }
+
+    virtual _connection_base2<arg1_type, arg2_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
+    {
+      return new _connection2<dest_type, arg1_type, arg2_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
+    }
+
+    virtual void emit(arg1_type a1, arg2_type a2)
+    {
+      (m_pobject->*m_pmemfun)(a1, a2);
+    }
+
+    virtual has_slots<mt_policy>* getdest() const
+    {
+      return m_pobject;
+    }
+
+  private:
+    dest_type* m_pobject;
+    void (dest_type::* m_pmemfun)(arg1_type, arg2_type);
   };
 
@@ -1342,41 +1342,41 @@
   class _connection3 : public _connection_base3<arg1_type, arg2_type, arg3_type, mt_policy>
   {
-    public:
-      _connection3()
-      {
-        pobject = NULL;
-        pmemfun = NULL;
-      }
-
-      _connection3(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
-                   arg2_type, arg3_type))
-      {
-        m_pobject = pobject;
-        m_pmemfun = pmemfun;
-      }
-
-      virtual _connection_base3<arg1_type, arg2_type, arg3_type, mt_policy>* clone()
-      {
-        return new _connection3<dest_type, arg1_type, arg2_type, arg3_type, mt_policy>(*this);
-      }
-
-      virtual _connection_base3<arg1_type, arg2_type, arg3_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
-      {
-        return new _connection3<dest_type, arg1_type, arg2_type, arg3_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
-      }
-
-      virtual void emit(arg1_type a1, arg2_type a2, arg3_type a3)
-      {
-        (m_pobject->*m_pmemfun)(a1, a2, a3);
-      }
-
-      virtual has_slots<mt_policy>* getdest() const
-      {
-        return m_pobject;
-      }
-
-    private:
-      dest_type* m_pobject;
-      void (dest_type::* m_pmemfun)(arg1_type, arg2_type, arg3_type);
+  public:
+    _connection3()
+    {
+      m_pobject = NULL;
+      m_pmemfun = NULL;
+    }
+
+    _connection3(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
+                 arg2_type, arg3_type))
+    {
+      m_pobject = pobject;
+      m_pmemfun = pmemfun;
+    }
+
+    virtual _connection_base3<arg1_type, arg2_type, arg3_type, mt_policy>* clone()
+    {
+      return new _connection3<dest_type, arg1_type, arg2_type, arg3_type, mt_policy>(*this);
+    }
+
+    virtual _connection_base3<arg1_type, arg2_type, arg3_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
+    {
+      return new _connection3<dest_type, arg1_type, arg2_type, arg3_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
+    }
+
+    virtual void emit(arg1_type a1, arg2_type a2, arg3_type a3)
+    {
+      (m_pobject->*m_pmemfun)(a1, a2, a3);
+    }
+
+    virtual has_slots<mt_policy>* getdest() const
+    {
+      return m_pobject;
+    }
+
+  private:
+    dest_type* m_pobject;
+    void (dest_type::* m_pmemfun)(arg1_type, arg2_type, arg3_type);
   };
 
@@ -1386,43 +1386,43 @@
         arg3_type, arg4_type, mt_policy>
   {
-    public:
-      _connection4()
-      {
-        pobject = NULL;
-        pmemfun = NULL;
-      }
-
-      _connection4(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
-                   arg2_type, arg3_type, arg4_type))
-      {
-        m_pobject = pobject;
-        m_pmemfun = pmemfun;
-      }
-
-      virtual _connection_base4<arg1_type, arg2_type, arg3_type, arg4_type, mt_policy>* clone()
-      {
-        return new _connection4<dest_type, arg1_type, arg2_type, arg3_type, arg4_type, mt_policy>(*this);
-      }
-
-      virtual _connection_base4<arg1_type, arg2_type, arg3_type, arg4_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
-      {
-        return new _connection4<dest_type, arg1_type, arg2_type, arg3_type, arg4_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
-      }
-
-      virtual void emit(arg1_type a1, arg2_type a2, arg3_type a3,
-                        arg4_type a4)
-      {
-        (m_pobject->*m_pmemfun)(a1, a2, a3, a4);
-      }
-
-      virtual has_slots<mt_policy>* getdest() const
-      {
-        return m_pobject;
-      }
-
-    private:
-      dest_type* m_pobject;
-      void (dest_type::* m_pmemfun)(arg1_type, arg2_type, arg3_type,
-                                    arg4_type);
+  public:
+    _connection4()
+    {
+      m_pobject = NULL;
+      m_pmemfun = NULL;
+    }
+
+    _connection4(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
+                 arg2_type, arg3_type, arg4_type))
+    {
+      m_pobject = pobject;
+      m_pmemfun = pmemfun;
+    }
+
+    virtual _connection_base4<arg1_type, arg2_type, arg3_type, arg4_type, mt_policy>* clone()
+    {
+      return new _connection4<dest_type, arg1_type, arg2_type, arg3_type, arg4_type, mt_policy>(*this);
+    }
+
+    virtual _connection_base4<arg1_type, arg2_type, arg3_type, arg4_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
+    {
+      return new _connection4<dest_type, arg1_type, arg2_type, arg3_type, arg4_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
+    }
+
+    virtual void emit(arg1_type a1, arg2_type a2, arg3_type a3,
+                      arg4_type a4)
+    {
+      (m_pobject->*m_pmemfun)(a1, a2, a3, a4);
+    }
+
+    virtual has_slots<mt_policy>* getdest() const
+    {
+      return m_pobject;
+    }
+
+  private:
+    dest_type* m_pobject;
+    void (dest_type::* m_pmemfun)(arg1_type, arg2_type, arg3_type,
+                                  arg4_type);
   };
 
@@ -1432,47 +1432,47 @@
         arg3_type, arg4_type, arg5_type, mt_policy>
   {
-    public:
-      _connection5()
-      {
-        pobject = NULL;
-        pmemfun = NULL;
-      }
-
-      _connection5(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
-                   arg2_type, arg3_type, arg4_type, arg5_type))
-      {
-        m_pobject = pobject;
-        m_pmemfun = pmemfun;
-      }
-
-      virtual _connection_base5<arg1_type, arg2_type, arg3_type, arg4_type,
-      arg5_type, mt_policy>* clone()
-      {
-        return new _connection5<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
-               arg5_type, mt_policy>(*this);
-      }
-
-      virtual _connection_base5<arg1_type, arg2_type, arg3_type, arg4_type,
-      arg5_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
-      {
-        return new _connection5<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
-               arg5_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
-      }
-
-      virtual void emit(arg1_type a1, arg2_type a2, arg3_type a3, arg4_type a4,
-                        arg5_type a5)
-      {
-        (m_pobject->*m_pmemfun)(a1, a2, a3, a4, a5);
-      }
-
-      virtual has_slots<mt_policy>* getdest() const
-      {
-        return m_pobject;
-      }
-
-    private:
-      dest_type* m_pobject;
-      void (dest_type::* m_pmemfun)(arg1_type, arg2_type, arg3_type, arg4_type,
-                                    arg5_type);
+  public:
+    _connection5()
+    {
+      m_pobject = NULL;
+      m_pmemfun = NULL;
+    }
+
+    _connection5(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
+                 arg2_type, arg3_type, arg4_type, arg5_type))
+    {
+      m_pobject = pobject;
+      m_pmemfun = pmemfun;
+    }
+
+    virtual _connection_base5<arg1_type, arg2_type, arg3_type, arg4_type,
+    arg5_type, mt_policy>* clone()
+    {
+      return new _connection5<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
+             arg5_type, mt_policy>(*this);
+    }
+
+    virtual _connection_base5<arg1_type, arg2_type, arg3_type, arg4_type,
+    arg5_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
+    {
+      return new _connection5<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
+             arg5_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
+    }
+
+    virtual void emit(arg1_type a1, arg2_type a2, arg3_type a3, arg4_type a4,
+                      arg5_type a5)
+    {
+      (m_pobject->*m_pmemfun)(a1, a2, a3, a4, a5);
+    }
+
+    virtual has_slots<mt_policy>* getdest() const
+    {
+      return m_pobject;
+    }
+
+  private:
+    dest_type* m_pobject;
+    void (dest_type::* m_pmemfun)(arg1_type, arg2_type, arg3_type, arg4_type,
+                                  arg5_type);
   };
 
@@ -1482,47 +1482,47 @@
         arg3_type, arg4_type, arg5_type, arg6_type, mt_policy>
   {
-    public:
-      _connection6()
-      {
-        pobject = NULL;
-        pmemfun = NULL;
-      }
-
-      _connection6(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
-                   arg2_type, arg3_type, arg4_type, arg5_type, arg6_type))
-      {
-        m_pobject = pobject;
-        m_pmemfun = pmemfun;
-      }
-
-      virtual _connection_base6<arg1_type, arg2_type, arg3_type, arg4_type,
-      arg5_type, arg6_type, mt_policy>* clone()
-      {
-        return new _connection6<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
-               arg5_type, arg6_type, mt_policy>(*this);
-      }
-
-      virtual _connection_base6<arg1_type, arg2_type, arg3_type, arg4_type,
-      arg5_type, arg6_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
-      {
-        return new _connection6<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
-               arg5_type, arg6_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
-      }
-
-      virtual void emit(arg1_type a1, arg2_type a2, arg3_type a3, arg4_type a4,
-                        arg5_type a5, arg6_type a6)
-      {
-        (m_pobject->*m_pmemfun)(a1, a2, a3, a4, a5, a6);
-      }
-
-      virtual has_slots<mt_policy>* getdest() const
-      {
-        return m_pobject;
-      }
-
-    private:
-      dest_type* m_pobject;
-      void (dest_type::* m_pmemfun)(arg1_type, arg2_type, arg3_type, arg4_type,
-                                    arg5_type, arg6_type);
+  public:
+    _connection6()
+    {
+      m_pobject = NULL;
+      m_pmemfun = NULL;
+    }
+
+    _connection6(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
+                 arg2_type, arg3_type, arg4_type, arg5_type, arg6_type))
+    {
+      m_pobject = pobject;
+      m_pmemfun = pmemfun;
+    }
+
+    virtual _connection_base6<arg1_type, arg2_type, arg3_type, arg4_type,
+    arg5_type, arg6_type, mt_policy>* clone()
+    {
+      return new _connection6<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
+             arg5_type, arg6_type, mt_policy>(*this);
+    }
+
+    virtual _connection_base6<arg1_type, arg2_type, arg3_type, arg4_type,
+    arg5_type, arg6_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
+    {
+      return new _connection6<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
+             arg5_type, arg6_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
+    }
+
+    virtual void emit(arg1_type a1, arg2_type a2, arg3_type a3, arg4_type a4,
+                      arg5_type a5, arg6_type a6)
+    {
+      (m_pobject->*m_pmemfun)(a1, a2, a3, a4, a5, a6);
+    }
+
+    virtual has_slots<mt_policy>* getdest() const
+    {
+      return m_pobject;
+    }
+
+  private:
+    dest_type* m_pobject;
+    void (dest_type::* m_pmemfun)(arg1_type, arg2_type, arg3_type, arg4_type,
+                                  arg5_type, arg6_type);
   };
 
@@ -1532,47 +1532,47 @@
         arg3_type, arg4_type, arg5_type, arg6_type, arg7_type, mt_policy>
   {
-    public:
-      _connection7()
-      {
-        pobject = NULL;
-        pmemfun = NULL;
-      }
-
-      _connection7(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
-                   arg2_type, arg3_type, arg4_type, arg5_type, arg6_type, arg7_type))
-      {
-        m_pobject = pobject;
-        m_pmemfun = pmemfun;
-      }
-
-      virtual _connection_base7<arg1_type, arg2_type, arg3_type, arg4_type,
-      arg5_type, arg6_type, arg7_type, mt_policy>* clone()
-      {
-        return new _connection7<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
-               arg5_type, arg6_type, arg7_type, mt_policy>(*this);
-      }
-
-      virtual _connection_base7<arg1_type, arg2_type, arg3_type, arg4_type,
-      arg5_type, arg6_type, arg7_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
-      {
-        return new _connection7<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
-               arg5_type, arg6_type, arg7_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
-      }
-
-      virtual void emit(arg1_type a1, arg2_type a2, arg3_type a3, arg4_type a4,
-                        arg5_type a5, arg6_type a6, arg7_type a7)
-      {
-        (m_pobject->*m_pmemfun)(a1, a2, a3, a4, a5, a6, a7);
-      }
-
-      virtual has_slots<mt_policy>* getdest() const
-      {
-        return m_pobject;
-      }
-
-    private:
-      dest_type* m_pobject;
-      void (dest_type::* m_pmemfun)(arg1_type, arg2_type, arg3_type, arg4_type,
-                                    arg5_type, arg6_type, arg7_type);
+  public:
+    _connection7()
+    {
+      m_pobject = NULL;
+      m_pmemfun = NULL;
+    }
+
+    _connection7(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
+                 arg2_type, arg3_type, arg4_type, arg5_type, arg6_type, arg7_type))
+    {
+      m_pobject = pobject;
+      m_pmemfun = pmemfun;
+    }
+
+    virtual _connection_base7<arg1_type, arg2_type, arg3_type, arg4_type,
+    arg5_type, arg6_type, arg7_type, mt_policy>* clone()
+    {
+      return new _connection7<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
+             arg5_type, arg6_type, arg7_type, mt_policy>(*this);
+    }
+
+    virtual _connection_base7<arg1_type, arg2_type, arg3_type, arg4_type,
+    arg5_type, arg6_type, arg7_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
+    {
+      return new _connection7<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
+             arg5_type, arg6_type, arg7_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
+    }
+
+    virtual void emit(arg1_type a1, arg2_type a2, arg3_type a3, arg4_type a4,
+                      arg5_type a5, arg6_type a6, arg7_type a7)
+    {
+      (m_pobject->*m_pmemfun)(a1, a2, a3, a4, a5, a6, a7);
+    }
+
+    virtual has_slots<mt_policy>* getdest() const
+    {
+      return m_pobject;
+    }
+
+  private:
+    dest_type* m_pobject;
+    void (dest_type::* m_pmemfun)(arg1_type, arg2_type, arg3_type, arg4_type,
+                                  arg5_type, arg6_type, arg7_type);
   };
 
@@ -1583,48 +1583,48 @@
         arg3_type, arg4_type, arg5_type, arg6_type, arg7_type, arg8_type, mt_policy>
   {
-    public:
-      _connection8()
-      {
-        pobject = NULL;
-        pmemfun = NULL;
-      }
-
-      _connection8(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
-                   arg2_type, arg3_type, arg4_type, arg5_type, arg6_type,
-                   arg7_type, arg8_type))
-      {
-        m_pobject = pobject;
-        m_pmemfun = pmemfun;
-      }
-
-      virtual _connection_base8<arg1_type, arg2_type, arg3_type, arg4_type,
-      arg5_type, arg6_type, arg7_type, arg8_type, mt_policy>* clone()
-      {
-        return new _connection8<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
-               arg5_type, arg6_type, arg7_type, arg8_type, mt_policy>(*this);
-      }
-
-      virtual _connection_base8<arg1_type, arg2_type, arg3_type, arg4_type,
-      arg5_type, arg6_type, arg7_type, arg8_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
-      {
-        return new _connection8<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
-               arg5_type, arg6_type, arg7_type, arg8_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
-      }
-
-      virtual void emit(arg1_type a1, arg2_type a2, arg3_type a3, arg4_type a4,
-                        arg5_type a5, arg6_type a6, arg7_type a7, arg8_type a8)
-      {
-        (m_pobject->*m_pmemfun)(a1, a2, a3, a4, a5, a6, a7, a8);
-      }
-
-      virtual has_slots<mt_policy>* getdest() const
-      {
-        return m_pobject;
-      }
-
-    private:
-      dest_type* m_pobject;
-      void (dest_type::* m_pmemfun)(arg1_type, arg2_type, arg3_type, arg4_type,
-                                    arg5_type, arg6_type, arg7_type, arg8_type);
+  public:
+    _connection8()
+    {
+      m_pobject = NULL;
+      m_pmemfun = NULL;
+    }
+
+    _connection8(dest_type* pobject, void (dest_type::*pmemfun)(arg1_type,
+                 arg2_type, arg3_type, arg4_type, arg5_type, arg6_type,
+                 arg7_type, arg8_type))
+    {
+      m_pobject = pobject;
+      m_pmemfun = pmemfun;
+    }
+
+    virtual _connection_base8<arg1_type, arg2_type, arg3_type, arg4_type,
+    arg5_type, arg6_type, arg7_type, arg8_type, mt_policy>* clone()
+    {
+      return new _connection8<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
+             arg5_type, arg6_type, arg7_type, arg8_type, mt_policy>(*this);
+    }
+
+    virtual _connection_base8<arg1_type, arg2_type, arg3_type, arg4_type,
+    arg5_type, arg6_type, arg7_type, arg8_type, mt_policy>* duplicate(has_slots<mt_policy>* pnewdest)
+    {
+      return new _connection8<dest_type, arg1_type, arg2_type, arg3_type, arg4_type,
+             arg5_type, arg6_type, arg7_type, arg8_type, mt_policy>((dest_type *)pnewdest, m_pmemfun);
+    }
+
+    virtual void emit(arg1_type a1, arg2_type a2, arg3_type a3, arg4_type a4,
+                      arg5_type a5, arg6_type a6, arg7_type a7, arg8_type a8)
+    {
+      (m_pobject->*m_pmemfun)(a1, a2, a3, a4, a5, a6, a7, a8);
+    }
+
+    virtual has_slots<mt_policy>* getdest() const
+    {
+      return m_pobject;
+    }
+
+  private:
+    dest_type* m_pobject;
+    void (dest_type::* m_pmemfun)(arg1_type, arg2_type, arg3_type, arg4_type,
+                                  arg5_type, arg6_type, arg7_type, arg8_type);
   };
 
@@ -1632,59 +1632,59 @@
   class signal0 : public _signal_base0<mt_policy>
   {
-    public:
-      signal0()
-      {
-        ;
-      }
-
-      signal0(const signal0<mt_policy>& s)
-          : _signal_base0<mt_policy>(s)
-      {
-        ;
-      }
-
-      template<class desttype>
-      void connect(desttype* pclass, void (desttype::*pmemfun)())
-      {
-        lock_block<mt_policy> lock(this);
-        _connection0<desttype, mt_policy>* conn =
-          new _connection0<desttype, mt_policy>(pclass, pmemfun);
-        m_connected_slots.push_back(conn);
-        pclass->signal_connect(this);
-      }
-
-      void emit()
-      {
-        lock_block<mt_policy> lock(this);
-        typename connections_list::const_iterator itNext, it = m_connected_slots.begin();
-        typename connections_list::const_iterator itEnd = m_connected_slots.end();
-
-        while(it != itEnd)
-        {
-          itNext = it;
-          ++itNext;
-
-          (*it)->emit();
-
-          it = itNext;
-        }
-      }
-
-      void operator()()
-      {
-        lock_block<mt_policy> lock(this);
-        typename connections_list::const_iterator itNext, it = m_connected_slots.begin();
-        typename connections_list::const_iterator itEnd = m_connected_slots.end();
-
-        while(it != itEnd)
-        {
-          itNext = it;
-          ++itNext;
-
-          (*it)->emit();
-
-          it = itNext;
-        }
-      }
+  public:
+    signal0()
+    {
+      ;
+    }
+
+    signal0(const signal0<mt_policy>& s)
+        : _signal_base0<mt_policy>(s)
+    {
+      ;
+    }
+
+    template<class desttype>
+    void connect(desttype* pclass, void (desttype::*pmemfun)())
+    {
+      lock_block<mt_policy> lock(this);
+      _connection0<desttype, mt_policy>* conn =
+        new _connection0<desttype, mt_policy>(pclass, pmemfun);
+      this->m_connected_slots.push_back(conn);
+      pclass->signal_connect(this);
+    }
+
+    void emit()
+    {
+      lock_block<mt_policy> lock(this);
+      typename _signal_base0<mt_policy>::connections_list::const_iterator itNext, it = this->m_connected_slots.begin();
+      typename _signal_base0<mt_policy>::connections_list::const_iterator itEnd = this->m_connected_slots.end();
+
+      while(it != itEnd)
+      {
+        itNext = it;
+        ++itNext;
+
+        (*it)->emit();
+
+        it = itNext;
+      }
+    }
+
+    void operator()()
+    {
+      lock_block<mt_policy> lock(this);
+      typename _signal_base0<mt_policy>::connections_list::const_iterator itNext, it = this->m_connected_slots.begin();
+      typename _signal_base0<mt_policy>::connections_list::const_iterator itEnd = this->m_connected_slots.end();
+
+      while(it != itEnd)
+      {
+        itNext = it;
+        ++itNext;
+
+        (*it)->emit();
+
+        it = itNext;
+      }
+    }
   };
 
@@ -1692,59 +1692,59 @@
   class signal1 : public _signal_base1<arg1_type, mt_policy>
   {
-    public:
-      signal1()
-      {
-        ;
-      }
-
-      signal1(const signal1<arg1_type, mt_policy>& s)
-          : _signal_base1<arg1_type, mt_policy>(s)
-      {
-        ;
-      }
-
-      template<class desttype>
-      void connect(desttype* pclass, void (desttype::*pmemfun)(arg1_type))
-      {
-        lock_block<mt_policy> lock(this);
-        _connection1<desttype, arg1_type, mt_policy>* conn =
-          new _connection1<desttype, arg1_type, mt_policy>(pclass, pmemfun);
-        m_connected_slots.push_back(conn);
-        pclass->signal_connect(this);
-      }
-
-      void emit(arg1_type a1)
-      {
-        lock_block<mt_policy> lock(this);
-        typename connections_list::const_iterator itNext, it = m_connected_slots.begin();
-        typename connections_list::const_iterator itEnd = m_connected_slots.end();
-
-        while(it != itEnd)
-        {
-          itNext = it;
-          ++itNext;
-
-          (*it)->emit(a1);
-
-          it = itNext;
-        }
-      }
-
-      void operator()(arg1_type a1)
-      {
-        lock_block<mt_policy> lock(this);
-        typename connections_list::const_iterator itNext, it = m_connected_slots.begin();
-        typename connections_list::const_iterator itEnd = m_connected_slots.end();
-
-        while(it != itEnd)
-        {
-          itNext = it;
-          ++itNext;
-
-          (*it)->emit(a1);
-
-          it = itNext;
-        }
-      }
+  public:
+    signal1()
+    {
+      ;
+    }
+
+    signal1(const signal1<arg1_type, mt_policy>& s)
+        : _signal_base1<arg1_type, mt_policy>(s)
+    {
+      ;
+    }
+
+    template<class desttype>
+    void connect(desttype* pclass, void (desttype::*pmemfun)(arg1_type))
+    {
+      lock_block<mt_policy> lock(this);
+      _connection1<desttype, arg1_type, mt_policy>* conn =
+        new _connection1<desttype, arg1_type, mt_policy>(pclass, pmemfun);
+      this->m_connected_slots.push_back(conn);
+      pclass->signal_connect(this);
+    }
+
+    void emit(arg1_type a1)
+    {
+      lock_block<mt_policy> lock(this);
+      typename _signal_base1<arg1_type, mt_policy>::connections_list::const_iterator itNext, it = this->m_connected_slots.begin();
+      typename _signal_base1<arg1_type, mt_policy>::connections_list::const_iterator itEnd = this->m_connected_slots.end();
+
+      while(it != itEnd)
+      {
+        itNext = it;
+        ++itNext;
+
+        (*it)->emit(a1);
+
+        it = itNext;
+      }
+    }
+
+    void operator()(arg1_type a1)
+    {
+      lock_block<mt_policy> lock(this);
+      typename _signal_base1<arg1_type, mt_policy>::connections_list::const_iterator itNext, it = this->m_connected_slots.begin();
+      typename _signal_base1<arg1_type, mt_policy>::connections_list::const_iterator itEnd = this->m_connected_slots.end();
+
+      while(it != itEnd)
+      {
+        itNext = it;
+        ++itNext;
+
+        (*it)->emit(a1);
+
+        it = itNext;
+      }
+    }
   };
 
